package com.FranckBarbier._Java._Railcar_control_system_client;

public class Control_center_client {

    /**
     * JNDI
     */
    private static javax.naming.Context _jndi_context;
    /**
     * JMS
     */
    public final static int Alert100_priority = 9; // highest priority in JMS
    public final static int Alert80_priority = 5; // lowest of the higher priorities in JMS
    public final static int Terminal_crossing_priority = 0; // lowest priority in JMS
    public final static int Terminal_stopping_priority = 0; // lowest priority in JMS
    private static javax.jms.QueueConnectionFactory _queue_connection_factory;
    private static javax.jms.Queue _queue;
    private static javax.jms.QueueConnection _queue_connection;
    private static javax.jms.QueueSession _queue_session;
    private static javax.jms.QueueSender _queue_sender;
    /**
     * WS
     */
    @javax.xml.ws.WebServiceRef(wsdlLocation = "META-INF/wsdl/localhost_8080/Railcar_new_destination/Railcar_new_destination.wsdl")
    private static com.FranckBarbier._Java._Railcar_control_system_client._Railcar_new_destination.RailcarNewDestination_Service _Railcar_new_destination_service;
    @javax.xml.ws.WebServiceRef(wsdlLocation = "META-INF/wsdl/localhost_8080/Terminal_new_destination/Terminal_new_destination.wsdl")
    private static com.FranckBarbier._Java._Railcar_control_system_client._Terminal_new_destination.TerminalNewDestination_Service _Terminal_new_destination_service;

    public Control_center_client() {
        try {
            _jndi_context = new javax.naming.InitialContext();
            _queue_connection_factory = (javax.jms.QueueConnectionFactory) _jndi_context.lookup("jms/Control_center_queue_factory");
            _queue = (javax.jms.Queue) _jndi_context.lookup("jms/Control_center_queue");
            _queue_connection = _queue_connection_factory.createQueueConnection();
            _queue_session = _queue_connection.createQueueSession(false, javax.jms.Session.AUTO_ACKNOWLEDGE);
            _queue_sender = _queue_session.createSender(_queue);
        } catch (javax.naming.NamingException ne) {
            System.err.println(Control_center_client.class.getName() + ne.getMessage() + ", " + ne.getExplanation());
        } catch (javax.jms.JMSException jmse) {
            System.err.println(Control_center_client.class.getName() + jmse.getMessage() + ": " + jmse.getErrorCode() + ", " + jmse.getLinkedException().getMessage());
        }
    }

    public void alert100(String terminal, String railcar, boolean is_clockwise) {
        try {
            // 'alert100' messages have higher priorities over 'alert80', 'terminal_crossing' and 'terminal_stopping'
            _queue_sender.send(_queue_session.createTextMessage(com.FranckBarbier._Java._Railcar_control_system.Control_center.Alert100 + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + terminal + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + railcar + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + (is_clockwise ? "1" : "0")), javax.jms.Message.DEFAULT_DELIVERY_MODE, Alert100_priority, javax.jms.Message.DEFAULT_TIME_TO_LIVE);
        } catch (Exception e) {
            System.err.println("Control center client (alert100): " + e.getMessage());
            System.exit(1);
        }
    }

    public void alert80(String terminal, String railcar, boolean is_clockwise) {
        try {
            // 'alert80' messages have higher priorities over 'terminal_crossing' and 'terminal_stopping'
            _queue_sender.send(_queue_session.createTextMessage(com.FranckBarbier._Java._Railcar_control_system.Control_center.Alert80 + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + terminal + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + railcar + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + (is_clockwise ? "1" : "0")), javax.jms.Message.DEFAULT_DELIVERY_MODE, Alert80_priority, javax.jms.Message.DEFAULT_TIME_TO_LIVE);
        } catch (Exception e) {
            System.err.println("Control center client (alert80): " + e.getMessage());
            System.exit(1);
        }
    }

    public void railcar_new_destination(String railcar, String another_terminal) {
        com.FranckBarbier._Java._Railcar_control_system_client._Railcar_new_destination.RailcarNewDestination port = _Railcar_new_destination_service.getRailcarNewDestinationPort();
        port.railcarNewDestination(railcar, another_terminal);
    }

    private void terminal_new_destination(String terminal, String another_terminal) {
        com.FranckBarbier._Java._Railcar_control_system_client._Terminal_new_destination.TerminalNewDestination port = _Terminal_new_destination_service.getTerminalNewDestinationPort();
        port.terminalNewDestination(terminal, another_terminal);
    }

    public static void main(String[] args) {
        Control_center_client control_center_client = new Control_center_client();

        control_center_client.railcar_new_destination("R2", "T2");
        control_center_client.railcar_new_destination("R1", "T2");
        control_center_client.terminal_new_destination("T2", "T1");

        control_center_client.alert100("T2", "R1", true);
        control_center_client.alert100("T2", "R2", true);
        control_center_client.alert80("T2", "R2", true);

        control_center_client.alert100("T2", "R3", false);
        control_center_client.alert80("T2", "R3", false);

        // Delay is for test:
        try {
            Thread.sleep(1000);
        } catch (InterruptedException ex) {
            java.util.logging.Logger.getLogger(Control_center_client.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }

        control_center_client.alert80("T2", "R1", true);

// Caution: re-execution involves resetting the database to its initial state, namely:
//        delete from Railcar;
//        insert into Railcar values('R1','T1','T2',1);
//        insert into Railcar values('R2','T1','T2',1);
//        insert into Railcar values('R3','T2','T3',0);
        try {
            _queue_connection.close(); // => _queue_session.close(); =>  _queue_sender.close();
            _jndi_context.close();
        } catch (Exception e) {
            System.err.println(Control_center_client.class.getName() + e.getMessage());
            System.exit(1);
        }
    }
}
